## bittwist 1.0

=== Makefile ===
SHELL = /bin/sh

prefix = /usr
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
mandir = ${prefix}/share/man/man1

CC ?= gcc
DEBUG = -g
CFLAGS ?= -O2
CFLAGS += $(DEBUG)
SRC = src
DOC = doc

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644

all: bittwist bittwistb bittwiste

bittwist:
	$(CC) $(CFLAGS) $(SRC)/bittwist.c -o $(SRC)/bittwist -I/usr/local/include -L/usr/local/lib -lpcap

bittwistb:
	$(CC) $(CFLAGS) $(SRC)/bittwistb.c -o $(SRC)/bittwistb -I/usr/local/include -L/usr/local/lib -lpcap

bittwiste:
	$(CC) $(CFLAGS) $(SRC)/bittwiste.c -o $(SRC)/bittwiste -I/usr/local/include -L/usr/local/lib -lpcap

clean:
	rm -f $(SRC)/bittwist $(SRC)/bittwistb $(SRC)/bittwiste

install:
	mkdir -p $(bindir)
	chmod 755 $(bindir)
	$(INSTALL_PROGRAM) $(SRC)/bittwist $(SRC)/bittwistb $(SRC)/bittwiste $(bindir)
	mkdir -p $(mandir)
	chmod 755 $(mandir)
	$(INSTALL_DATA) $(DOC)/bittwist.1 $(DOC)/bittwistb.1 $(DOC)/bittwiste.1 $(mandir)

uninstall:
	rm -f $(bindir)/bittwist $(bindir)/bittwistb $(bindir)/bittwiste
	rm -f $(mandir)/bittwist.1 $(mandir)/bittwistb.1 $(mandir)/bittwiste.1

## bittwist 2.0

=== Makefile ===
SHELL = /bin/sh

prefix = /usr
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
mandir = ${prefix}/share/man/man1

CC ?= gcc
DEBUG = -g
CFLAGS ?= -O2
CFLAGS += $(DEBUG)
SRC = src
DOC = doc

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644

all: bittwist bittwiste

bittwist:
	$(CC) $(CFLAGS) $(SRC)/bittwist.c -o $(SRC)/bittwist -I/usr/local/include -L/usr/local/lib -lpcap

bittwiste:
	$(CC) $(CFLAGS) $(SRC)/bittwiste.c -o $(SRC)/bittwiste -I/usr/local/include -L/usr/local/lib -lpcap

clean:
	rm -f $(SRC)/bittwist $(SRC)/bittwiste

install:
	mkdir -p $(bindir)
	chmod 755 $(bindir)
	$(INSTALL_PROGRAM) $(SRC)/bittwist $(SRC)/bittwiste $(bindir)
	mkdir -p $(mandir)
	chmod 755 $(mandir)
	$(INSTALL_DATA) $(DOC)/bittwist.1 $(DOC)/bittwiste.1 $(mandir)

uninstall:
	rm -f $(bindir)/bittwist $(bindir)/bittwiste
	rm -f $(mandir)/bittwist.1 $(mandir)/bittwiste.1

=== debian/changelog ===
bittwist (2.0-9) unstable; urgency=medium

  * Bumped DH level to 10.
  * debian/control:
      - Bumped Standards-Version to 3.9.8.
      - Updated the Vcs-* fields to use https instead of http and git.
  * debian/copyright: updated the packaging copyright years.
  * debian/gbp.conf: no longer used by me... Removed.
  * debian/patches/:
      - Added 30_fix-spellings-manpage.patch, to fix bittwiste.1.
      - bittwiste.1.patch: no longer needed. Removed.
      - bittwist.1.patch: no longer needed. Removed.
      - fix-gcc-warning: renamed to 10_fix-gcc-warning.patch.
      - Makefile.patch: renamed to 20_improve-Makefile.patch.
  * debian/rules: removed the --parallel option from dh.
  * debian/watch: bumped to version 4.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 17 Nov 2016 20:12:59 -0200

bittwist (2.0-8) unstable; urgency=medium

  * debian/control: fix a spelling error in long description.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 16 May 2015 22:20:10 -0300

bittwist (2.0-7) unstable; urgency=medium

  * Upload to unstable. Welcome Jessie Stable!

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 28 Apr 2015 19:39:21 -0300

bittwist (2.0-6) experimental; urgency=medium

  * debian/copyright: updated the packaging copyright years.
  * debian/patches/fix-gcc-warning: added to fix a GCC warning.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 10 Feb 2015 23:20:40 -0200

bittwist (2.0-5) unstable; urgency=medium

  * debian/control: updated the Standards-Version to 3.9.6.
  * debian/patches/Makefile.patch: changed to improve the
      hardening system.
  * debian/rules:
      - Added the DEB_BUILD_MAINT_OPTIONS variable to fix the
        issues pointed by blhc.
      - Removed an useless comment.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 12 Oct 2014 02:26:57 -0300

bittwist (2.0-4) unstable; urgency=medium

  * New maintainer email address.
  * debian/control:
      - Bumped Standards-Version from 3.9.4 to 3.9.5.
      - Updated de Vcs-Browser field.
  * debian/copyright: updated copyright packaging years.
  * debian/gbp.conf: added to allow git-buildpackage usage.
  * debian/watch: improved.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 02 Aug 2014 18:13:14 -0300

bittwist (2.0-3) unstable; urgency=low

  * debian/control: updated VCS (migrated from svn to git).

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Fri, 02 Aug 2013 10:47:25 -0300

bittwist (2.0-2) unstable; urgency=low

  * Bump debhelper level to 9.
  * debian/control: re-added VCS fields.
  * debian/rules:
      - Added --parallel to DH.
      - Removed some comments.

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Tue, 30 Apr 2013 20:42:31 -0300

bittwist (2.0-1) unstable; urgency=low

  * New upstream release.
  * Reintroduced in Debian (Closes: #705352).
  * Added GCC hardening in Makefile.patch.
  * Migrations:
      - debian format from 1.0 to 3.0.
      - debhelper version from 7 to 8.
      - patch system from dpatch to quilt.
  * debian/control:
      - Changed tcpdump from Recommends to Suggests.
      - Updated Standards-Version from 3.8.4 to 3.9.4.
      - Updated long description.
      - Removed Vcs-Svn and Vcs-Browser fields.
  * debian/copyright: updated to new format.
  * debian/README.source: removed because it useless now.
  * debian/rules: updated to new (reduced) format.

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Thu, 11 Apr 2013 20:58:40 -0300

bittwist (1.1-1) unstable; urgency=low

  * New upstream release.
  * Added 02 patch to fix hyfen used as minus signal in manpages.
  * Removed extra blank spaces in debian/{copyright,rules}.
  * Updated debhelper version from 5 to 7.
  * debian/control:
      - Added ${misc:Depends} in Depends field.
      - Changed libpcap0.8-dev to libpcap-dev in Build-Depends.
      - Removed XS from two Vcs lines.
      - Updated information about SVN (Vcs lines).
      - Updated Standards-Version from 3.7.2 to 3.8.4.
  * debian/copyright:
      - Added the "copyright" word in packaging announce.
      - Changed the point to GPL from "/usr/share/common-licenses/GPL" to
        "/usr/share/common-licenses/GPL-2".
  * debian/rules:
      - Changed from dh_clean -k to dh_prep.
      - Made empty binary-indep target.
      - Removed build redundancy from binary-arch target.
      - Removed binary-indep from binary target.
  * debian/watch: fixed the version check.

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Sat, 27 Feb 2010 21:49:15 -0300

bittwist (1.0-1) unstable; urgency=low

  * New upstream release.
  * Added year 2007 in debian/copyright.
  * Fixed a typo in long description in debian/control. Thanks to Gunnar
    Wolf <gwolf@debian.org>. (Closes: #449063)

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Fri, 02 Nov 2007 18:25:56 -0200

bittwist (0.80-2) UNRELEASED; urgency=low

  * Added Homepage field in debian/control.
  * Removed debian/docs. The BUGS file instructs users to report bugs to
    upstream, however, Debian users should use Debian Bug Tracking System
    (BTS).

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Sat, 27 Oct 2007 21:07:07 -0200

bittwist (0.80-1) unstable; urgency=low

  * Initial release. (Closes: #432724)

 -- Joao Eriberto Mota Filho <eriberto@eriberto.pro.br>  Fri, 27 Jul 2007 09:49:34 -0300

=== debian/control ===
Source: bittwist
Section: net
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Build-Depends: debhelper (>= 10), libpcap-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/bittwist.git
Vcs-Git: https://anonscm.debian.org/git/collab-maint/bittwist.git
Homepage: http://bittwist.sf.net

Package: bittwist
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: tcpdump | wireshark
Description: libpcap based Ethernet packet generator
 bittwist (or Bit-Twist) is designed to complement tcpdump, which by itself has
 done a great job in capturing network traffic. Bit-Twist can regenerate the
 captured traffic onto a live network (the packets are generated from tcpdump
 trace file, generating a .pcap file).
 .
 Bit-Twist also comes with a comprehensive trace file editor to allow one to
 change the contents of a trace file (bittwiste).
 .
 Generally, a packet generator is useful in simulating networking traffic or
 scenario, testing firewall, IDS, and IPS, and troubleshooting various network
 problems.
 .
 The Bit-Twist features are:
 .
    * runs on Mac OS X (and *BSD), Linux, and Windows;
    * send multiple trace files at a time;
    * send packets at a specific speed or line rate in Mbps;
    * comprehensive trace file editor with control over most fields in
      Ethernet, ARP, IP, ICMP, TCP, and UDP headers with automatic header
      checksum correction;
    * append user payload to existing packets after a specific header;
    * select a specific range of packets and save them in another trace file;
    * highly scriptable - with proper manipulation you can turn Bit-Twist
      into an extremely flexible packet generator tool;
    * if you are teaching Computer Networks classes, you may find Bit-Twist
      useful as a practical teaching material. It gives your students a
      hands-on experience to learn various networking protocols etc.

=== debian/watch ===
version=4
http://sf.net/bittwist/bittwist-linux-(\d\S+)\.tar\.(?:bz2|gz|xz)

## bittwist 3.4

=== Makefile ===
# SPDX-License-Identifier: GPL-2.0-or-later
#
# Makefile for Bit-Twist project
# Copyright (C) 2006 - 2023 Addy Yeow Chin Heng <ayeowch@gmail.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

SHELL = /bin/sh

prefix = /usr/local
exec_prefix = ${prefix}
bindir = ${exec_prefix}/bin
mandir = ${prefix}/share/man/man1

# Bit-Twist 3.1 and earlier was using /usr instead of /usr/local.
# These old paths are defined below to allow `sudo make uninstall` to also
# remove any installation of Bit-Twist 3.1 or earlier.
old_prefix = /usr
old_exec_prefix = ${old_prefix}
old_bindir = ${old_exec_prefix}/bin
old_mandir = ${old_prefix}/share/man/man1

CC ?= gcc
DEBUG = -g
CFLAGS ?= -std=gnu17
CFLAGS += -O2
CFLAGS += ${DEBUG} -Wall
SRC = src
DOC = doc

CPPCHECK ?= cppcheck

CLANG_FORMAT ?= clang-format

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644

all: bittwist bittwiste

bittwist:
	$(CC) $(CFLAGS) $(SRC)/bittwist.c $(SRC)/token_bucket.c -o $(SRC)/bittwist -I/usr/local/include -L/usr/local/lib -lpcap

bittwiste:
	$(CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/template_pcap.c -o $(SRC)/bittwiste -I/usr/local/include -L/usr/local/lib -lpcap

clean:
	rm -f $(SRC)/bittwist $(SRC)/bittwiste

check:
	$(CPPCHECK) --enable=warning .

format:
	$(CLANG_FORMAT) -i src/def.h src/token_bucket.h src/token_bucket.c src/bittwist.h src/bittwist.c src/bittwiste.h src/bittwiste.c

install:
	mkdir -p $(bindir)
	chmod 755 $(bindir)
	$(INSTALL_PROGRAM) $(SRC)/bittwist $(SRC)/bittwiste $(bindir)
	mkdir -p $(mandir)
	chmod 755 $(mandir)
	$(INSTALL_DATA) $(DOC)/bittwist.1 $(DOC)/bittwiste.1 $(mandir)

uninstall:
	@rm -vf $(wildcard $(bindir)/bittwist)
	@rm -vf $(wildcard $(bindir)/bittwiste)
	@rm -vf $(wildcard $(mandir)/bittwist.1)
	@rm -vf $(wildcard $(mandir)/bittwiste.1)
	@rm -vf $(wildcard $(old_bindir)/bittwist)
	@rm -vf $(wildcard $(old_bindir)/bittwiste)
	@rm -vf $(wildcard $(old_mandir)/bittwist.1)
	@rm -vf $(wildcard $(old_mandir)/bittwiste.1)

=== debian/changelog ===
bittwist (3.4-1) unstable; urgency=medium

  * New upstream version 3.4
  * Update d/p/20_Makefile.patch for new upstream version 3.4
  * d/control: update long Description from new upstream version README.md
  * rm d/p/30_fix-spellings-manpage.patch, useless for new upstream version

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 14 Jun 2023 17:28:47 +0800

bittwist (3.1-1) unstable; urgency=medium

  * New upstream version 3.1
  * Refresh patches
  * d/copyright:
      - add xiao sheng wen for debian dir
      - update year info to 2023
      - update Source field
  * d/control:
      - Bump Standards-Version: 4.6.2
      - B-D add cppcheck libpcap0.8-dev, remove libpcap-dev
      - update Homepage to https://bittwist.sourceforge.io
      - update Vcs-Git, use -b debian/latest
  * add d/docs
  * add debian/gbp.conf
  * add debian/upstream/metadata
  * Run wrap-and-sort -asbkt

 -- xiao sheng wen <atzlinux@sina.com>  Thu, 01 Jun 2023 11:32:51 +0800

bittwist (2.0-15) unstable; urgency=medium

  [ 肖盛文 ]
  * Bumped debhelper-compat 13
  * New maintainer (Closes: #951173)
  * d/copyright: add Upstream-Contact: Addy Yeow Chin Heng <ayeowch@gmail.com>

 -- xiao sheng wen <atzlinux@sina.com>  Fri, 08 May 2020 19:41:12 +0800

bittwist (2.0-14) unstable; urgency=medium

  * QA upload.
  * debian/copyright:
      - Added packaging rights for me.
      - Using a secure copyright format in URI.
  * debian/patches/10_fix-gcc-warning.patch: updated to fix a build warning.

 -- Thiago Andrade Marques <thmarques@gmail.com>  Sat, 21 Mar 2020 22:37:20 -0300

bittwist (2.0-13) unstable; urgency=medium

  * QA upload.
  * Set Debian QA Group as maintainer. (see: #951173)
  * debian/control: bumped Standards-Version to 4.5.0.
  * debian/copyright: updated packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 11 Feb 2020 18:03:54 -0300

bittwist (2.0-12) unstable; urgency=medium

  * Using new DH level format. Consequently:
      - debian/compat: removed.
      - debian/control: changed from 'debhelper' to 'debhelper-compat' in
        Build-Depends field and bumped level to 12.
  * debian/control:
      - Added 'Rules-Requires-Root: no' to source stanza.
      - Bumped Standards-Version to 4.4.1.
  * debian/copyright: updated packaging copyright years.
  * debian/salsa-ci.yml: added to provide CI tests for Salsa.
  * debian/watch: using variables instead of expressions.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 04 Nov 2019 19:19:17 -0300

bittwist (2.0-11) unstable; urgency=medium

  [ Joao Eriberto Mota Filho ]
  * debian/control: bumped Standards-Version to 4.2.1.
  * debian/tests/control: use a restriction instead of '2>'.

  [ Ondřej Nový ]
  * debian/watch: use https protocol.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 27 Nov 2018 20:02:05 -0200

bittwist (2.0-10) unstable; urgency=medium

  * Bumped DH level to 11.
  * debian/control:
      - Bumped Standards-Version to 4.2.0.
      - Changed Vcs-* URLs to salsa.debian.org.
  * debian/copyright: updated packaging years.
  * debian/source/include-binaries: added to control debian/tests/test.pcap.
  * debian/tests/control: created to perform tests.
  * debian/tests/test.pcap: added to be used as test.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 22 Aug 2018 17:09:34 -0300

## bittwist 3.8

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Makefile for Bit-Twist project
-# Copyright (C) 2006 - 2023 Addy Yeow Chin Heng <ayeowch@gmail.com>
+# Copyright (C) 2006 - 2023 Addy Yeow <ayeowch@gmail.com>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -35,7 +35,7 @@
 CC ?= gcc
 DEBUG = -g
 CFLAGS ?= -std=gnu17
-CFLAGS += -O2
+CFLAGS += -O3
 CFLAGS += ${DEBUG} -Wall
 SRC = src
 DOC = doc
@@ -54,16 +54,16 @@
 	$(CC) $(CFLAGS) $(SRC)/bittwist.c $(SRC)/token_bucket.c -o $(SRC)/bittwist -I/usr/local/include -L/usr/local/lib -lpcap
 
 bittwiste:
-	$(CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/template_pcap.c -o $(SRC)/bittwiste -I/usr/local/include -L/usr/local/lib -lpcap
+	$(CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/tinymt/tinymt64.c $(SRC)/template_pcap.c -o $(SRC)/bittwiste -I $(SRC)/tinymt -I/usr/local/include -L/usr/local/lib -lpcap
 
 clean:
 	rm -f $(SRC)/bittwist $(SRC)/bittwiste
 
 check:
-	$(CPPCHECK) --enable=warning .
+	$(CPPCHECK) --enable=warning $(SRC)
 
 format:
-	$(CLANG_FORMAT) -i src/def.h src/token_bucket.h src/token_bucket.c src/bittwist.h src/bittwist.c src/bittwiste.h src/bittwiste.c
+	$(CLANG_FORMAT) -i src/def.h src/token_bucket.h src/token_bucket.c src/template_pcap.h src/template_pcap.c src/bittwist.h src/bittwist.c src/bittwiste.h src/bittwiste.c
 
 install:
 	mkdir -p $(bindir)

=== tests/requirements.txt ===
asttokens==2.2.1
backcall==0.2.0
black==23.3.0
click==8.1.3
decorator==5.1.1
executing==1.2.0
flake8==6.0.0
iniconfig==2.0.0
ipdb==0.13.13
ipython==8.13.2
jedi==0.18.2
matplotlib-inline==0.1.6
mccabe==0.7.0
mypy-extensions==1.0.0
packaging==23.1
parso==0.8.3
pathspec==0.11.1
pexpect==4.8.0
pickleshare==0.7.5
platformdirs==3.5.1
pluggy==1.0.0
prompt-toolkit==3.0.38
ptyprocess==0.7.0
pure-eval==0.2.2
pycodestyle==2.10.0
pyflakes==3.0.1
Pygments==2.15.1
pytest==7.3.1
six==1.16.0
stack-data==0.6.2
traitlets==5.9.0
wcwidth==0.2.6

=== debian/changelog ===
bittwist (3.8-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:35:02 +1100

bittwist (3.8-1build1) noble; urgency=medium

  * No-change rebuild for libpcap t64.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 13:58:19 +0100

bittwist (3.8-1) unstable; urgency=medium

  * New upstream version 3.8
  * d/copyright:
      - update Source: to https://github.com/ayeowch/bittwist
      - update Upstream AUTHORS name
  * Update d/p/20_Makefile.patch for new upstream version

 -- xiao sheng wen <atzlinux@sina.com>  Mon, 14 Aug 2023 18:17:02 +0800

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,25 @@
 Source: bittwist
 Section: net
 Priority: optional
-Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Build-Depends: debhelper (>= 10), libpcap-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/bittwist.git
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/bittwist.git
-Homepage: http://bittwist.sf.net
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Build-Depends:
+ cppcheck,
+ debhelper-compat (= 13),
+ libpcap0.8-dev,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/bittwist
+Vcs-Git: https://salsa.debian.org/debian/bittwist.git -b debian/latest
+Homepage: https://bittwist.sourceforge.io
 
 Package: bittwist
 Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Suggests: tcpdump | wireshark
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Suggests:
+ tcpdump | wireshark,
 Description: libpcap based Ethernet packet generator
  bittwist (or Bit-Twist) is designed to complement tcpdump, which by itself has
  done a great job in capturing network traffic. Bit-Twist can regenerate the
@@ -27,13 +35,21 @@
  .
  The Bit-Twist features are:
  .
-    * runs on Mac OS X (and *BSD), Linux, and Windows;
+    * runs on Linux, BSD, macOS, and Windows;
     * send multiple trace files at a time;
-    * send packets at a specific speed or line rate in Mbps;
+    * send packets at a specific speed or up to your NIC line rate in Mbps using
+      built-in token bucket algorithm;
     * comprehensive trace file editor with control over most fields in
       Ethernet, ARP, IP, ICMP, TCP, and UDP headers with automatic header
       checksum correction;
+    * comprehensive trace file editor to edit most fields in
+      Ethernet, ARP, IPv4, IPv6, ICMPv4, ICMPv6, TCP, and UDP headers;
+    * automatic header checksum correction;
+    * send packets with custom QoS bits to test classification/queuing features
+      of switches/routers;
     * append user payload to existing packets after a specific header;
+    * append user payload (e.g. copy of hex stream from Wireshark) to existing
+      packets after a specific header;
     * select a specific range of packets and save them in another trace file;
     * highly scriptable - with proper manipulation you can turn Bit-Twist
       into an extremely flexible packet generator tool;

## bittwist 4.6+ds

=== debian/changelog ===
bittwist (4.6+ds-1) unstable; urgency=medium

  * New upstream version
  * d/watch: add repack,repacksuffix=+ds opts
  * Uploaders add atzlinux@debian.org email
  * update d/p/30_not-use-static-linking.patch for new upstream

 -- xiao sheng wen <atzlinux@debian.org>  Wed, 30 Oct 2024 10:57:46 +0800

bittwist (4.1+ds-1) unstable; urgency=medium

  * New upstream version 4.1+ds
  * Bump Standards-Version: 4.7.0
  * update d/p/20_Makefile.patch
  * add d/p/30_not-use-static-linking.patch
  * d/copyright:
      - add Files-Excluded: bin npcap-sdk directory
      - update year info to 2024
      - add src/tinymt/* BSD-3-clause
  * d/watch: add opts=dversionmangle=s/\.ds//
  * d/rules: add execute_before_dh_auto_build target

 -- xiao sheng wen <atzlinux@sina.com>  Sat, 12 Oct 2024 21:05:02 +0800

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

execute_before_dh_auto_build:
	mkdir -pv bin

%:
	dh $@

## bittwist 4.7%2Bds

=== debian/changelog ===
bittwist (4.7+ds-2build1) resolute; urgency=medium

  * No-change mass rebuild for Ubuntu 26.04 (LP: #2132257)

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 13 Jan 2026 20:43:03 +0000

bittwist (4.7+ds-2) unstable; urgency=medium

  * d/rules: execute_after_dh_auto_test target use DEB_BUILD_ARCH_ENDIAN to
    run test only on the little ENDIAN CPU, closes: #1090793
  * d/copyright: update-debian-copyright year info to 2025

 -- xiao sheng wen <atzlinux@sina.com>  Wed, 01 Jan 2025 15:09:40 +0800

bittwist (4.7+ds-1) unstable; urgency=medium

  * New upstream version
  * d/rules: add execute_after_dh_auto_test target
  * add d/clean to clear debian/tests/pcap/ directory

 -- xiao sheng wen <atzlinux@sina.com>  Mon, 18 Nov 2024 15:43:11 +0800

## bittwist 4.7+ds

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # SPDX-License-Identifier: GPL-2.0-or-later
 #
 # Makefile for Bit-Twist project
-# Copyright (C) 2006 - 2023 Addy Yeow <ayeowch@gmail.com>
+# Copyright (C) 2006 - 2024 Addy Yeow <ayeowch@gmail.com>
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -33,12 +33,20 @@
 old_mandir = ${old_prefix}/share/man/man1
 
 CC ?= gcc
-DEBUG = -g
 CFLAGS ?= -std=gnu17
 CFLAGS += -O3
-CFLAGS += ${DEBUG} -Wall
+CFLAGS += -Wall
+
+# Use make ENABLE_DEBUG=0 to disable debug.
+ENABLE_DEBUG ?= 1
+DEBUG = -g
+ifeq ($(ENABLE_DEBUG), 1)
+CFLAGS += $(DEBUG)
+endif
+
 SRC = src
 DOC = doc
+BIN = bin
 
 CPPCHECK ?= cppcheck
 
@@ -48,27 +56,46 @@
 INSTALL_PROGRAM = ${INSTALL}
 INSTALL_DATA = ${INSTALL} -m 644
 
-all: bittwist bittwiste
+UNAME_S := $(shell uname -s)
+
+# Use static linking to libpcap on Linux.
+ifeq ($(UNAME_S),Linux)
+	LPCAP = -Wl,-Bstatic -lpcap -Wl,-Bdynamic
+else
+	LPCAP = -lpcap
+endif
+
+# MinGW-w64 compiler for Windows cross-compilation.
+MINGW_CC = x86_64-w64-mingw32-gcc
+
+ifneq ("$(shell which $(MINGW_CC) 2>/dev/null)","")
+	WINDOWS_TARGETS = windows
+endif
+
+# To ensure reproducible outputs.
+export SOURCE_DATE_EPOCH=0
+
+all: bittwist bittwiste $(WINDOWS_TARGETS)
 
 bittwist:
-	$(CC) $(CFLAGS) $(SRC)/bittwist.c $(SRC)/token_bucket.c -o $(SRC)/bittwist -I/usr/local/include -L/usr/local/lib -lpcap
+	$(CC) $(CFLAGS) $(SRC)/bittwist.c $(SRC)/token_bucket.c -o $(BIN)/bittwist -I/usr/local/include -L/usr/local/lib $(LPCAP)
 
 bittwiste:
-	$(CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/tinymt/tinymt64.c $(SRC)/template_pcap.c -o $(SRC)/bittwiste -I $(SRC)/tinymt -I/usr/local/include -L/usr/local/lib -lpcap
+	$(CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/tinymt/tinymt64.c $(SRC)/template_pcap.c -o $(BIN)/bittwiste -I $(SRC)/tinymt -I/usr/local/include -L/usr/local/lib
 
 clean:
-	rm -f $(SRC)/bittwist $(SRC)/bittwiste
+	rm -f $(BIN)/bittwist $(BIN)/bittwiste
 
 check:
 	$(CPPCHECK) --enable=warning $(SRC)
 
 format:
-	$(CLANG_FORMAT) -i src/def.h src/token_bucket.h src/token_bucket.c src/template_pcap.h src/template_pcap.c src/bittwist.h src/bittwist.c src/bittwiste.h src/bittwiste.c
+	$(CLANG_FORMAT) -i src/windows_utils.h src/def.h src/token_bucket.h src/token_bucket.c src/template_pcap.h src/template_pcap.c src/bittwist.h src/bittwist.c src/bittwiste.h src/bittwiste.c
 
 install:
 	mkdir -p $(bindir)
 	chmod 755 $(bindir)
-	$(INSTALL_PROGRAM) $(SRC)/bittwist $(SRC)/bittwiste $(bindir)
+	$(INSTALL_PROGRAM) $(BIN)/bittwist $(BIN)/bittwiste $(bindir)
 	mkdir -p $(mandir)
 	chmod 755 $(mandir)
 	$(INSTALL_DATA) $(DOC)/bittwist.1 $(DOC)/bittwiste.1 $(mandir)
@@ -82,3 +109,11 @@
 	@rm -vf $(wildcard $(old_bindir)/bittwiste)
 	@rm -vf $(wildcard $(old_mandir)/bittwist.1)
 	@rm -vf $(wildcard $(old_mandir)/bittwiste.1)
+
+windows: bittwist_windows bittwiste_windows
+
+bittwist_windows:
+	$(MINGW_CC) $(CFLAGS) $(SRC)/bittwist.c $(SRC)/token_bucket.c -o $(BIN)/bittwist.exe -I npcap-sdk/Include -L npcap-sdk/Lib/x64 -lwpcap
+
+bittwiste_windows:
+	$(MINGW_CC) $(CFLAGS) $(SRC)/bittwiste.c $(SRC)/tinymt/tinymt64.c $(SRC)/template_pcap.c -o $(BIN)/bittwiste.exe -I $(SRC)/tinymt -I npcap-sdk/Include -lws2_32

=== tests/requirements.txt ===
asttokens==2.4.1
beautifulsoup4==4.12.3
black==24.10.0
certifi==2024.8.30
charset-normalizer==3.4.0
click==8.1.7
decorator==5.1.1
executing==2.1.0
flake8==7.1.1
idna==3.10
iniconfig==2.0.0
ipdb==0.13.13
ipython==8.28.0
jedi==0.19.1
matplotlib-inline==0.1.7
mccabe==0.7.0
mypy-extensions==1.0.0
numpy==2.1.2
packaging==24.1
pandas==2.2.3
parso==0.8.4
pathspec==0.12.1
pexpect==4.9.0
platformdirs==4.3.6
pluggy==1.5.0
prompt_toolkit==3.0.48
ptyprocess==0.7.0
pure_eval==0.2.3
pycodestyle==2.12.1
pyflakes==3.2.0
Pygments==2.18.0
pytest==8.3.3
python-dateutil==2.9.0.post0
pytz==2024.2
requests==2.32.3
scipy==1.14.1
six==1.16.0
soupsieve==2.6
stack-data==0.6.3
traitlets==5.14.3
tzdata==2024.2
urllib3==2.2.3
wcwidth==0.2.13

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: bittwist
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Maintainer: xiao sheng wen <atzlinux@sina.com>
+Uploaders:
+ xiao sheng wen <atzlinux@debian.org>,
 Build-Depends:
  cppcheck,
  debhelper-compat (= 13),
  libpcap0.8-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/bittwist
 Vcs-Git: https://salsa.debian.org/debian/bittwist.git -b debian/latest

=== debian/rules ===
--- 
+++ 
@@ -6,5 +6,11 @@
 execute_before_dh_auto_build:
 	mkdir -pv bin
 
+execute_after_dh_auto_test:
+	mkdir -pv debian/tests/pcap/
+ifeq ($(DEB_BUILD_ARCH_ENDIAN),little)
+	for i in tests/pcap/*;do ./bin/bittwiste -I "$$i" -O debian/"$$i";done
+endif
+
 %:
 	dh $@

=== debian/tests/control ===
Test-Command: bittwist -d

Test-Command: bittwiste -I debian/tests/test.pcap -O debian/tests/test.bittwiste.pcap
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts="dversionmangle=s/\.ds//,repack,repacksuffix=+ds" \
https://sf.net/bittwist/bittwist-linux-@ANY_VERSION@@ARCHIVE_EXT@
